// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Vision.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/vision__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ball`
#include "rcss3d_agent_msgs/msg/detail/ball__functions.h"
// Member `field_lines`
#include "rcss3d_agent_msgs/msg/detail/field_line__functions.h"
// Member `flags`
#include "rcss3d_agent_msgs/msg/detail/flag__functions.h"
// Member `goalposts`
#include "rcss3d_agent_msgs/msg/detail/goalpost__functions.h"
// Member `players`
#include "rcss3d_agent_msgs/msg/detail/player__functions.h"

bool
rcss3d_agent_msgs__msg__Vision__init(rcss3d_agent_msgs__msg__Vision * msg)
{
  if (!msg) {
    return false;
  }
  // ball
  if (!rcss3d_agent_msgs__msg__Ball__Sequence__init(&msg->ball, 0)) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
    return false;
  }
  // field_lines
  if (!rcss3d_agent_msgs__msg__FieldLine__Sequence__init(&msg->field_lines, 0)) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
    return false;
  }
  // flags
  if (!rcss3d_agent_msgs__msg__Flag__Sequence__init(&msg->flags, 0)) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
    return false;
  }
  // goalposts
  if (!rcss3d_agent_msgs__msg__Goalpost__Sequence__init(&msg->goalposts, 0)) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
    return false;
  }
  // players
  if (!rcss3d_agent_msgs__msg__Player__Sequence__init(&msg->players, 0)) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Vision__fini(rcss3d_agent_msgs__msg__Vision * msg)
{
  if (!msg) {
    return;
  }
  // ball
  rcss3d_agent_msgs__msg__Ball__Sequence__fini(&msg->ball);
  // field_lines
  rcss3d_agent_msgs__msg__FieldLine__Sequence__fini(&msg->field_lines);
  // flags
  rcss3d_agent_msgs__msg__Flag__Sequence__fini(&msg->flags);
  // goalposts
  rcss3d_agent_msgs__msg__Goalpost__Sequence__fini(&msg->goalposts);
  // players
  rcss3d_agent_msgs__msg__Player__Sequence__fini(&msg->players);
}

rcss3d_agent_msgs__msg__Vision *
rcss3d_agent_msgs__msg__Vision__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Vision * msg = (rcss3d_agent_msgs__msg__Vision *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Vision), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Vision));
  bool success = rcss3d_agent_msgs__msg__Vision__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Vision__destroy(rcss3d_agent_msgs__msg__Vision * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__Vision__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__Vision__Sequence__init(rcss3d_agent_msgs__msg__Vision__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Vision * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__Vision *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__Vision), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Vision__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Vision__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Vision__Sequence__fini(rcss3d_agent_msgs__msg__Vision__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Vision__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Vision__Sequence *
rcss3d_agent_msgs__msg__Vision__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Vision__Sequence * array = (rcss3d_agent_msgs__msg__Vision__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Vision__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Vision__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Vision__Sequence__destroy(rcss3d_agent_msgs__msg__Vision__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__Vision__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
